pub use VkPipelineCreateFlags::*;

#[repr(u32)]
#[derive(Clone, Copy, Debug, Eq, PartialEq)]
pub enum VkPipelineCreateFlags {
    VK_PIPELINE_CREATE_DISABLE_OPTIMIZATION_BIT = 0x0000_0001,
    VK_PIPELINE_CREATE_ALLOW_DERIVATIVES_BIT = 0x0000_0002,
    VK_PIPELINE_CREATE_DERIVATIVE_BIT = 0x0000_0004,
    VK_PIPELINE_CREATE_VIEW_INDEX_FROM_DEVICE_INDEX_BIT = 0x0000_0008,
    VK_PIPELINE_CREATE_DISPATCH_BASE_BIT = 0x0000_0010,
    VK_PIPELINE_CREATE_DEFER_COMPILE_BIT_NV = 0x0000_0020,
    VK_PIPELINE_CREATE_CAPTURE_STATISTICS_BIT_KHR = 0x0000_0040,
    VK_PIPELINE_CREATE_CAPTURE_INTERNAL_REPRESENTATIONS_BIT_KHR = 0x0000_0080,
    VK_PIPELINE_CREATE_FAIL_ON_PIPELINE_COMPILE_REQUIRED_BIT_EXT = 0x0000_0100,
    VK_PIPELINE_CREATE_EARLY_RETURN_ON_FAILURE_BIT_EXT = 0x0000_0200,
    VK_PIPELINE_CREATE_LIBRARY_BIT_KHR = 0x0000_0800,
    VK_PIPELINE_CREATE_RAY_TRACING_SKIP_TRIANGLES_BIT_KHR = 0x0000_1000,
    VK_PIPELINE_CREATE_RAY_TRACING_SKIP_AABBS_BIT_KHR = 0x0000_2000,
    VK_PIPELINE_CREATE_RAY_TRACING_NO_NULL_ANY_HIT_SHADERS_BIT_KHR = 0x0000_4000,
    VK_PIPELINE_CREATE_RAY_TRACING_NO_NULL_CLOSEST_HIT_SHADERS_BIT_KHR = 0x0000_8000,
    VK_PIPELINE_CREATE_RAY_TRACING_NO_NULL_MISS_SHADERS_BIT_KHR = 0x0001_0000,
    VK_PIPELINE_CREATE_RAY_TRACING_NO_NULL_INTERSECTION_SHADERS_BIT_KHR = 0x0002_0000,
    VK_PIPELINE_CREATE_RAY_TRACING_SHADER_GROUP_HANDLE_CAPTURE_REPLAY_BIT_KHR = 0x0008_0000,
    VK_PIPELINE_CREATE_INDIRECT_BINDABLE_BIT_NV = 0x0004_0000,
}

#[repr(C)]
#[derive(Clone, Copy, Eq, PartialEq, Hash)]
pub struct VkPipelineCreateFlagBits(u32);
SetupVkFlags!(VkPipelineCreateFlags, VkPipelineCreateFlagBits);
