use crate::prelude::*;

use std::os::raw::c_char;

#[repr(C)]
#[derive(Copy, Clone)]
pub struct VkExtensionProperties {
    pub extensionName: [c_char; VK_MAX_EXTENSION_NAME_SIZE as usize],
    pub specVersion: u32,
}

impl VkExtensionProperties {
    pub fn extension_name(&self) -> Result<VkString, std::str::Utf8Error> {
        VkString::try_from(&self.extensionName as *const c_char)
    }
}

impl Default for VkExtensionProperties {
    fn default() -> Self {
        VkExtensionProperties {
            extensionName: [0; VK_MAX_EXTENSION_NAME_SIZE as usize],
            specVersion: 0,
        }
    }
}
